function ___$insertStyle(css) {
  if (!css) {
    return;
  }
  if (typeof window === 'undefined') {
    return;
  }

  var style = document.createElement('style');

  style.setAttribute('type', 'text/css');
  style.innerHTML = css;
  document.head.appendChild(style);
  return css;
}

import React, { createContext, useContext, useRef, useState, useEffect } from 'react';
import { Dimensions, StyleSheet, View, Text } from 'react-native';
import { WebView } from 'react-native-webview';

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?
Symbol.for("react.suspense_list"):60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.block"):60121,w=b?Symbol.for("react.fundamental"):60117,x=b?Symbol.for("react.responder"):60118,y=b?Symbol.for("react.scope"):60119;
function z(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function A(a){return z(a)===m}var AsyncMode=l;var ConcurrentMode=m;var ContextConsumer=k;var ContextProvider=h;var Element=c;var ForwardRef=n;var Fragment=e;var Lazy=t;var Memo=r;var Portal=d;
var Profiler=g;var StrictMode=f;var Suspense=p;var isAsyncMode=function(a){return A(a)||z(a)===l};var isConcurrentMode=A;var isContextConsumer=function(a){return z(a)===k};var isContextProvider=function(a){return z(a)===h};var isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};var isForwardRef=function(a){return z(a)===n};var isFragment=function(a){return z(a)===e};var isLazy=function(a){return z(a)===t};
var isMemo=function(a){return z(a)===r};var isPortal=function(a){return z(a)===d};var isProfiler=function(a){return z(a)===g};var isStrictMode=function(a){return z(a)===f};var isSuspense=function(a){return z(a)===p};
var isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===w||a.$$typeof===x||a.$$typeof===y||a.$$typeof===v)};var typeOf=z;

var reactIs_production_min = {
	AsyncMode: AsyncMode,
	ConcurrentMode: ConcurrentMode,
	ContextConsumer: ContextConsumer,
	ContextProvider: ContextProvider,
	Element: Element,
	ForwardRef: ForwardRef,
	Fragment: Fragment,
	Lazy: Lazy,
	Memo: Memo,
	Portal: Portal,
	Profiler: Profiler,
	StrictMode: StrictMode,
	Suspense: Suspense,
	isAsyncMode: isAsyncMode,
	isConcurrentMode: isConcurrentMode,
	isContextConsumer: isContextConsumer,
	isContextProvider: isContextProvider,
	isElement: isElement,
	isForwardRef: isForwardRef,
	isFragment: isFragment,
	isLazy: isLazy,
	isMemo: isMemo,
	isPortal: isPortal,
	isProfiler: isProfiler,
	isStrictMode: isStrictMode,
	isSuspense: isSuspense,
	isValidElementType: isValidElementType,
	typeOf: typeOf
};

var reactIs_development = createCommonjsModule(function (module, exports) {



if (process.env.NODE_ENV !== "production") {
  (function() {

// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
// nor polyfill, then a plain number is used for performance.
var hasSymbol = typeof Symbol === 'function' && Symbol.for;
var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
// (unstable) APIs that have been removed. Can we remove the symbols?

var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;

function isValidElementType(type) {
  return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
  type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
}

function typeOf(object) {
  if (typeof object === 'object' && object !== null) {
    var $$typeof = object.$$typeof;

    switch ($$typeof) {
      case REACT_ELEMENT_TYPE:
        var type = object.type;

        switch (type) {
          case REACT_ASYNC_MODE_TYPE:
          case REACT_CONCURRENT_MODE_TYPE:
          case REACT_FRAGMENT_TYPE:
          case REACT_PROFILER_TYPE:
          case REACT_STRICT_MODE_TYPE:
          case REACT_SUSPENSE_TYPE:
            return type;

          default:
            var $$typeofType = type && type.$$typeof;

            switch ($$typeofType) {
              case REACT_CONTEXT_TYPE:
              case REACT_FORWARD_REF_TYPE:
              case REACT_LAZY_TYPE:
              case REACT_MEMO_TYPE:
              case REACT_PROVIDER_TYPE:
                return $$typeofType;

              default:
                return $$typeof;
            }

        }

      case REACT_PORTAL_TYPE:
        return $$typeof;
    }
  }

  return undefined;
} // AsyncMode is deprecated along with isAsyncMode

var AsyncMode = REACT_ASYNC_MODE_TYPE;
var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
var ContextConsumer = REACT_CONTEXT_TYPE;
var ContextProvider = REACT_PROVIDER_TYPE;
var Element = REACT_ELEMENT_TYPE;
var ForwardRef = REACT_FORWARD_REF_TYPE;
var Fragment = REACT_FRAGMENT_TYPE;
var Lazy = REACT_LAZY_TYPE;
var Memo = REACT_MEMO_TYPE;
var Portal = REACT_PORTAL_TYPE;
var Profiler = REACT_PROFILER_TYPE;
var StrictMode = REACT_STRICT_MODE_TYPE;
var Suspense = REACT_SUSPENSE_TYPE;
var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

function isAsyncMode(object) {
  {
    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
    }
  }

  return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
}
function isConcurrentMode(object) {
  return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
}
function isContextConsumer(object) {
  return typeOf(object) === REACT_CONTEXT_TYPE;
}
function isContextProvider(object) {
  return typeOf(object) === REACT_PROVIDER_TYPE;
}
function isElement(object) {
  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
}
function isForwardRef(object) {
  return typeOf(object) === REACT_FORWARD_REF_TYPE;
}
function isFragment(object) {
  return typeOf(object) === REACT_FRAGMENT_TYPE;
}
function isLazy(object) {
  return typeOf(object) === REACT_LAZY_TYPE;
}
function isMemo(object) {
  return typeOf(object) === REACT_MEMO_TYPE;
}
function isPortal(object) {
  return typeOf(object) === REACT_PORTAL_TYPE;
}
function isProfiler(object) {
  return typeOf(object) === REACT_PROFILER_TYPE;
}
function isStrictMode(object) {
  return typeOf(object) === REACT_STRICT_MODE_TYPE;
}
function isSuspense(object) {
  return typeOf(object) === REACT_SUSPENSE_TYPE;
}

exports.AsyncMode = AsyncMode;
exports.ConcurrentMode = ConcurrentMode;
exports.ContextConsumer = ContextConsumer;
exports.ContextProvider = ContextProvider;
exports.Element = Element;
exports.ForwardRef = ForwardRef;
exports.Fragment = Fragment;
exports.Lazy = Lazy;
exports.Memo = Memo;
exports.Portal = Portal;
exports.Profiler = Profiler;
exports.StrictMode = StrictMode;
exports.Suspense = Suspense;
exports.isAsyncMode = isAsyncMode;
exports.isConcurrentMode = isConcurrentMode;
exports.isContextConsumer = isContextConsumer;
exports.isContextProvider = isContextProvider;
exports.isElement = isElement;
exports.isForwardRef = isForwardRef;
exports.isFragment = isFragment;
exports.isLazy = isLazy;
exports.isMemo = isMemo;
exports.isPortal = isPortal;
exports.isProfiler = isProfiler;
exports.isStrictMode = isStrictMode;
exports.isSuspense = isSuspense;
exports.isValidElementType = isValidElementType;
exports.typeOf = typeOf;
  })();
}
});
var reactIs_development_1 = reactIs_development.AsyncMode;
var reactIs_development_2 = reactIs_development.ConcurrentMode;
var reactIs_development_3 = reactIs_development.ContextConsumer;
var reactIs_development_4 = reactIs_development.ContextProvider;
var reactIs_development_5 = reactIs_development.Element;
var reactIs_development_6 = reactIs_development.ForwardRef;
var reactIs_development_7 = reactIs_development.Fragment;
var reactIs_development_8 = reactIs_development.Lazy;
var reactIs_development_9 = reactIs_development.Memo;
var reactIs_development_10 = reactIs_development.Portal;
var reactIs_development_11 = reactIs_development.Profiler;
var reactIs_development_12 = reactIs_development.StrictMode;
var reactIs_development_13 = reactIs_development.Suspense;
var reactIs_development_14 = reactIs_development.isAsyncMode;
var reactIs_development_15 = reactIs_development.isConcurrentMode;
var reactIs_development_16 = reactIs_development.isContextConsumer;
var reactIs_development_17 = reactIs_development.isContextProvider;
var reactIs_development_18 = reactIs_development.isElement;
var reactIs_development_19 = reactIs_development.isForwardRef;
var reactIs_development_20 = reactIs_development.isFragment;
var reactIs_development_21 = reactIs_development.isLazy;
var reactIs_development_22 = reactIs_development.isMemo;
var reactIs_development_23 = reactIs_development.isPortal;
var reactIs_development_24 = reactIs_development.isProfiler;
var reactIs_development_25 = reactIs_development.isStrictMode;
var reactIs_development_26 = reactIs_development.isSuspense;
var reactIs_development_27 = reactIs_development.isValidElementType;
var reactIs_development_28 = reactIs_development.typeOf;

var reactIs = createCommonjsModule(function (module) {

if (process.env.NODE_ENV === 'production') {
  module.exports = reactIs_production_min;
} else {
  module.exports = reactIs_development;
}
});

/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
/* eslint-disable no-unused-vars */
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (err) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (getOwnPropertySymbols) {
			symbols = getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

var ReactPropTypesSecret_1 = ReactPropTypesSecret;

var printWarning = function() {};

if (process.env.NODE_ENV !== 'production') {
  var ReactPropTypesSecret$1 = ReactPropTypesSecret_1;
  var loggedTypeFailures = {};
  var has = Function.call.bind(Object.prototype.hasOwnProperty);

  printWarning = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

/**
 * Assert that the values match with the type specs.
 * Error messages are memorized and will only be shown once.
 *
 * @param {object} typeSpecs Map of name to a ReactPropType
 * @param {object} values Runtime values that need to be type-checked
 * @param {string} location e.g. "prop", "context", "child context"
 * @param {string} componentName Name of the component for error messages.
 * @param {?Function} getStack Returns the component stack.
 * @private
 */
function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
  if (process.env.NODE_ENV !== 'production') {
    for (var typeSpecName in typeSpecs) {
      if (has(typeSpecs, typeSpecName)) {
        var error;
        // Prop type validation may throw. In case they do, we don't want to
        // fail the render phase where it didn't fail before. So we log it.
        // After these have been cleaned up, we'll let them throw.
        try {
          // This is intentionally an invariant that gets caught. It's the same
          // behavior as without this statement except with a better message.
          if (typeof typeSpecs[typeSpecName] !== 'function') {
            var err = Error(
              (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
              'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.'
            );
            err.name = 'Invariant Violation';
            throw err;
          }
          error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret$1);
        } catch (ex) {
          error = ex;
        }
        if (error && !(error instanceof Error)) {
          printWarning(
            (componentName || 'React class') + ': type specification of ' +
            location + ' `' + typeSpecName + '` is invalid; the type checker ' +
            'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
            'You may have forgotten to pass an argument to the type checker ' +
            'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
            'shape all require an argument).'
          );
        }
        if (error instanceof Error && !(error.message in loggedTypeFailures)) {
          // Only monitor this failure once because there tends to be a lot of the
          // same error.
          loggedTypeFailures[error.message] = true;

          var stack = getStack ? getStack() : '';

          printWarning(
            'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
          );
        }
      }
    }
  }
}

/**
 * Resets warning cache when testing.
 *
 * @private
 */
checkPropTypes.resetWarningCache = function() {
  if (process.env.NODE_ENV !== 'production') {
    loggedTypeFailures = {};
  }
};

var checkPropTypes_1 = checkPropTypes;

var has$1 = Function.call.bind(Object.prototype.hasOwnProperty);
var printWarning$1 = function() {};

if (process.env.NODE_ENV !== 'production') {
  printWarning$1 = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

function emptyFunctionThatReturnsNull() {
  return null;
}

var factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
  /* global Symbol */
  var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
  var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

  /**
   * Returns the iterator method function contained on the iterable object.
   *
   * Be sure to invoke the function with the iterable as context:
   *
   *     var iteratorFn = getIteratorFn(myIterable);
   *     if (iteratorFn) {
   *       var iterator = iteratorFn.call(myIterable);
   *       ...
   *     }
   *
   * @param {?object} maybeIterable
   * @return {?function}
   */
  function getIteratorFn(maybeIterable) {
    var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
    if (typeof iteratorFn === 'function') {
      return iteratorFn;
    }
  }

  /**
   * Collection of methods that allow declaration and validation of props that are
   * supplied to React components. Example usage:
   *
   *   var Props = require('ReactPropTypes');
   *   var MyArticle = React.createClass({
   *     propTypes: {
   *       // An optional string prop named "description".
   *       description: Props.string,
   *
   *       // A required enum prop named "category".
   *       category: Props.oneOf(['News','Photos']).isRequired,
   *
   *       // A prop named "dialog" that requires an instance of Dialog.
   *       dialog: Props.instanceOf(Dialog).isRequired
   *     },
   *     render: function() { ... }
   *   });
   *
   * A more formal specification of how these methods are used:
   *
   *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
   *   decl := ReactPropTypes.{type}(.isRequired)?
   *
   * Each and every declaration produces a function with the same signature. This
   * allows the creation of custom validation functions. For example:
   *
   *  var MyLink = React.createClass({
   *    propTypes: {
   *      // An optional string or URI prop named "href".
   *      href: function(props, propName, componentName) {
   *        var propValue = props[propName];
   *        if (propValue != null && typeof propValue !== 'string' &&
   *            !(propValue instanceof URI)) {
   *          return new Error(
   *            'Expected a string or an URI for ' + propName + ' in ' +
   *            componentName
   *          );
   *        }
   *      }
   *    },
   *    render: function() {...}
   *  });
   *
   * @internal
   */

  var ANONYMOUS = '<<anonymous>>';

  // Important!
  // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
  var ReactPropTypes = {
    array: createPrimitiveTypeChecker('array'),
    bool: createPrimitiveTypeChecker('boolean'),
    func: createPrimitiveTypeChecker('function'),
    number: createPrimitiveTypeChecker('number'),
    object: createPrimitiveTypeChecker('object'),
    string: createPrimitiveTypeChecker('string'),
    symbol: createPrimitiveTypeChecker('symbol'),

    any: createAnyTypeChecker(),
    arrayOf: createArrayOfTypeChecker,
    element: createElementTypeChecker(),
    elementType: createElementTypeTypeChecker(),
    instanceOf: createInstanceTypeChecker,
    node: createNodeChecker(),
    objectOf: createObjectOfTypeChecker,
    oneOf: createEnumTypeChecker,
    oneOfType: createUnionTypeChecker,
    shape: createShapeTypeChecker,
    exact: createStrictShapeTypeChecker,
  };

  /**
   * inlined Object.is polyfill to avoid requiring consumers ship their own
   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
   */
  /*eslint-disable no-self-compare*/
  function is(x, y) {
    // SameValue algorithm
    if (x === y) {
      // Steps 1-5, 7-10
      // Steps 6.b-6.e: +0 != -0
      return x !== 0 || 1 / x === 1 / y;
    } else {
      // Step 6.a: NaN == NaN
      return x !== x && y !== y;
    }
  }
  /*eslint-enable no-self-compare*/

  /**
   * We use an Error-like object for backward compatibility as people may call
   * PropTypes directly and inspect their output. However, we don't use real
   * Errors anymore. We don't inspect their stack anyway, and creating them
   * is prohibitively expensive if they are created too often, such as what
   * happens in oneOfType() for any type before the one that matched.
   */
  function PropTypeError(message) {
    this.message = message;
    this.stack = '';
  }
  // Make `instanceof Error` still work for returned errors.
  PropTypeError.prototype = Error.prototype;

  function createChainableTypeChecker(validate) {
    if (process.env.NODE_ENV !== 'production') {
      var manualPropTypeCallCache = {};
      var manualPropTypeWarningCount = 0;
    }
    function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
      componentName = componentName || ANONYMOUS;
      propFullName = propFullName || propName;

      if (secret !== ReactPropTypesSecret_1) {
        if (throwOnDirectAccess) {
          // New behavior only for users of `prop-types` package
          var err = new Error(
            'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
            'Use `PropTypes.checkPropTypes()` to call them. ' +
            'Read more at http://fb.me/use-check-prop-types'
          );
          err.name = 'Invariant Violation';
          throw err;
        } else if (process.env.NODE_ENV !== 'production' && typeof console !== 'undefined') {
          // Old behavior for people using React.PropTypes
          var cacheKey = componentName + ':' + propName;
          if (
            !manualPropTypeCallCache[cacheKey] &&
            // Avoid spamming the console because they are often not actionable except for lib authors
            manualPropTypeWarningCount < 3
          ) {
            printWarning$1(
              'You are manually calling a React.PropTypes validation ' +
              'function for the `' + propFullName + '` prop on `' + componentName  + '`. This is deprecated ' +
              'and will throw in the standalone `prop-types` package. ' +
              'You may be seeing this warning due to a third-party PropTypes ' +
              'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
            );
            manualPropTypeCallCache[cacheKey] = true;
            manualPropTypeWarningCount++;
          }
        }
      }
      if (props[propName] == null) {
        if (isRequired) {
          if (props[propName] === null) {
            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
          }
          return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
        }
        return null;
      } else {
        return validate(props, propName, componentName, location, propFullName);
      }
    }

    var chainedCheckType = checkType.bind(null, false);
    chainedCheckType.isRequired = checkType.bind(null, true);

    return chainedCheckType;
  }

  function createPrimitiveTypeChecker(expectedType) {
    function validate(props, propName, componentName, location, propFullName, secret) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== expectedType) {
        // `propValue` being instance of, say, date/regexp, pass the 'object'
        // check, but we can offer a more precise error message here rather than
        // 'of type `object`'.
        var preciseType = getPreciseType(propValue);

        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createAnyTypeChecker() {
    return createChainableTypeChecker(emptyFunctionThatReturnsNull);
  }

  function createArrayOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
      }
      var propValue = props[propName];
      if (!Array.isArray(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
      }
      for (var i = 0; i < propValue.length; i++) {
        var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);
        if (error instanceof Error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!isValidElement(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!reactIs.isValidElementType(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement type.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createInstanceTypeChecker(expectedClass) {
    function validate(props, propName, componentName, location, propFullName) {
      if (!(props[propName] instanceof expectedClass)) {
        var expectedClassName = expectedClass.name || ANONYMOUS;
        var actualClassName = getClassName(props[propName]);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createEnumTypeChecker(expectedValues) {
    if (!Array.isArray(expectedValues)) {
      if (process.env.NODE_ENV !== 'production') {
        if (arguments.length > 1) {
          printWarning$1(
            'Invalid arguments supplied to oneOf, expected an array, got ' + arguments.length + ' arguments. ' +
            'A common mistake is to write oneOf(x, y, z) instead of oneOf([x, y, z]).'
          );
        } else {
          printWarning$1('Invalid argument supplied to oneOf, expected an array.');
        }
      }
      return emptyFunctionThatReturnsNull;
    }

    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      for (var i = 0; i < expectedValues.length; i++) {
        if (is(propValue, expectedValues[i])) {
          return null;
        }
      }

      var valuesString = JSON.stringify(expectedValues, function replacer(key, value) {
        var type = getPreciseType(value);
        if (type === 'symbol') {
          return String(value);
        }
        return value;
      });
      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + String(propValue) + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createObjectOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
      }
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
      }
      for (var key in propValue) {
        if (has$1(propValue, key)) {
          var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error instanceof Error) {
            return error;
          }
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createUnionTypeChecker(arrayOfTypeCheckers) {
    if (!Array.isArray(arrayOfTypeCheckers)) {
      process.env.NODE_ENV !== 'production' ? printWarning$1('Invalid argument supplied to oneOfType, expected an instance of array.') : void 0;
      return emptyFunctionThatReturnsNull;
    }

    for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
      var checker = arrayOfTypeCheckers[i];
      if (typeof checker !== 'function') {
        printWarning$1(
          'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
          'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
        );
        return emptyFunctionThatReturnsNull;
      }
    }

    function validate(props, propName, componentName, location, propFullName) {
      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
        var checker = arrayOfTypeCheckers[i];
        if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
          return null;
        }
      }

      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createNodeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      if (!isNode(props[propName])) {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      for (var key in shapeTypes) {
        var checker = shapeTypes[key];
        if (!checker) {
          continue;
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createStrictShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      // We need to check all keys in case some are required but missing from
      // props.
      var allKeys = objectAssign({}, props[propName], shapeTypes);
      for (var key in allKeys) {
        var checker = shapeTypes[key];
        if (!checker) {
          return new PropTypeError(
            'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
            '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
            '\nValid keys: ' +  JSON.stringify(Object.keys(shapeTypes), null, '  ')
          );
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }

    return createChainableTypeChecker(validate);
  }

  function isNode(propValue) {
    switch (typeof propValue) {
      case 'number':
      case 'string':
      case 'undefined':
        return true;
      case 'boolean':
        return !propValue;
      case 'object':
        if (Array.isArray(propValue)) {
          return propValue.every(isNode);
        }
        if (propValue === null || isValidElement(propValue)) {
          return true;
        }

        var iteratorFn = getIteratorFn(propValue);
        if (iteratorFn) {
          var iterator = iteratorFn.call(propValue);
          var step;
          if (iteratorFn !== propValue.entries) {
            while (!(step = iterator.next()).done) {
              if (!isNode(step.value)) {
                return false;
              }
            }
          } else {
            // Iterator will provide entry [k,v] tuples rather than values.
            while (!(step = iterator.next()).done) {
              var entry = step.value;
              if (entry) {
                if (!isNode(entry[1])) {
                  return false;
                }
              }
            }
          }
        } else {
          return false;
        }

        return true;
      default:
        return false;
    }
  }

  function isSymbol(propType, propValue) {
    // Native Symbol.
    if (propType === 'symbol') {
      return true;
    }

    // falsy value can't be a Symbol
    if (!propValue) {
      return false;
    }

    // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
    if (propValue['@@toStringTag'] === 'Symbol') {
      return true;
    }

    // Fallback for non-spec compliant Symbols which are polyfilled.
    if (typeof Symbol === 'function' && propValue instanceof Symbol) {
      return true;
    }

    return false;
  }

  // Equivalent of `typeof` but with special handling for array and regexp.
  function getPropType(propValue) {
    var propType = typeof propValue;
    if (Array.isArray(propValue)) {
      return 'array';
    }
    if (propValue instanceof RegExp) {
      // Old webkits (at least until Android 4.0) return 'function' rather than
      // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
      // passes PropTypes.object.
      return 'object';
    }
    if (isSymbol(propType, propValue)) {
      return 'symbol';
    }
    return propType;
  }

  // This handles more types than `getPropType`. Only used for error messages.
  // See `createPrimitiveTypeChecker`.
  function getPreciseType(propValue) {
    if (typeof propValue === 'undefined' || propValue === null) {
      return '' + propValue;
    }
    var propType = getPropType(propValue);
    if (propType === 'object') {
      if (propValue instanceof Date) {
        return 'date';
      } else if (propValue instanceof RegExp) {
        return 'regexp';
      }
    }
    return propType;
  }

  // Returns a string that is postfixed to a warning about an invalid type.
  // For example, "undefined" or "of type array"
  function getPostfixForTypeWarning(value) {
    var type = getPreciseType(value);
    switch (type) {
      case 'array':
      case 'object':
        return 'an ' + type;
      case 'boolean':
      case 'date':
      case 'regexp':
        return 'a ' + type;
      default:
        return type;
    }
  }

  // Returns class name of the object, if any.
  function getClassName(propValue) {
    if (!propValue.constructor || !propValue.constructor.name) {
      return ANONYMOUS;
    }
    return propValue.constructor.name;
  }

  ReactPropTypes.checkPropTypes = checkPropTypes_1;
  ReactPropTypes.resetWarningCache = checkPropTypes_1.resetWarningCache;
  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

function emptyFunction() {}
function emptyFunctionWithReset() {}
emptyFunctionWithReset.resetWarningCache = emptyFunction;

var factoryWithThrowingShims = function() {
  function shim(props, propName, componentName, location, propFullName, secret) {
    if (secret === ReactPropTypesSecret_1) {
      // It is still safe when called from React.
      return;
    }
    var err = new Error(
      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
      'Use PropTypes.checkPropTypes() to call them. ' +
      'Read more at http://fb.me/use-check-prop-types'
    );
    err.name = 'Invariant Violation';
    throw err;
  }  shim.isRequired = shim;
  function getShim() {
    return shim;
  }  // Important!
  // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
  var ReactPropTypes = {
    array: shim,
    bool: shim,
    func: shim,
    number: shim,
    object: shim,
    string: shim,
    symbol: shim,

    any: shim,
    arrayOf: getShim,
    element: shim,
    elementType: shim,
    instanceOf: getShim,
    node: shim,
    objectOf: getShim,
    oneOf: getShim,
    oneOfType: getShim,
    shape: getShim,
    exact: getShim,

    checkPropTypes: emptyFunctionWithReset,
    resetWarningCache: emptyFunction
  };

  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

var propTypes = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

if (process.env.NODE_ENV !== 'production') {
  var ReactIs = reactIs;

  // By explicitly using `prop-types` you are opting into new development behavior.
  // http://fb.me/prop-types-in-prod
  var throwOnDirectAccess = true;
  module.exports = factoryWithTypeCheckers(ReactIs.isElement, throwOnDirectAccess);
} else {
  // By explicitly using `prop-types` you are opting into new production behavior.
  // http://fb.me/prop-types-in-prod
  module.exports = factoryWithThrowingShims();
}
});

var rngBrowser = createCommonjsModule(function (module) {
// Unique ID creation requires a high quality random # generator.  In the
// browser this is a little complicated due to unknown quality of Math.random()
// and inconsistent support for the `crypto` API.  We do the best we can via
// feature-detection

// getRandomValues needs to be invoked in a context where "this" is a Crypto
// implementation. Also, find the complete implementation of crypto on IE11.
var getRandomValues = (typeof(crypto) != 'undefined' && crypto.getRandomValues && crypto.getRandomValues.bind(crypto)) ||
                      (typeof(msCrypto) != 'undefined' && typeof window.msCrypto.getRandomValues == 'function' && msCrypto.getRandomValues.bind(msCrypto));

if (getRandomValues) {
  // WHATWG crypto RNG - http://wiki.whatwg.org/wiki/Crypto
  var rnds8 = new Uint8Array(16); // eslint-disable-line no-undef

  module.exports = function whatwgRNG() {
    getRandomValues(rnds8);
    return rnds8;
  };
} else {
  // Math.random()-based (RNG)
  //
  // If all else fails, use Math.random().  It's fast, but is of unspecified
  // quality.
  var rnds = new Array(16);

  module.exports = function mathRNG() {
    for (var i = 0, r; i < 16; i++) {
      if ((i & 0x03) === 0) r = Math.random() * 0x100000000;
      rnds[i] = r >>> ((i & 0x03) << 3) & 0xff;
    }

    return rnds;
  };
}
});

/**
 * Convert array of 16 byte values to UUID string format of the form:
 * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
 */
var byteToHex = [];
for (var i = 0; i < 256; ++i) {
  byteToHex[i] = (i + 0x100).toString(16).substr(1);
}

function bytesToUuid(buf, offset) {
  var i = offset || 0;
  var bth = byteToHex;
  // join used to fix memory issue caused by concatenation: https://bugs.chromium.org/p/v8/issues/detail?id=3175#c4
  return ([
    bth[buf[i++]], bth[buf[i++]],
    bth[buf[i++]], bth[buf[i++]], '-',
    bth[buf[i++]], bth[buf[i++]], '-',
    bth[buf[i++]], bth[buf[i++]], '-',
    bth[buf[i++]], bth[buf[i++]], '-',
    bth[buf[i++]], bth[buf[i++]],
    bth[buf[i++]], bth[buf[i++]],
    bth[buf[i++]], bth[buf[i++]]
  ]).join('');
}

var bytesToUuid_1 = bytesToUuid;

function v4(options, buf, offset) {
  var i = buf && offset || 0;

  if (typeof(options) == 'string') {
    buf = options === 'binary' ? new Array(16) : null;
    options = null;
  }
  options = options || {};

  var rnds = options.random || (options.rng || rngBrowser)();

  // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`
  rnds[6] = (rnds[6] & 0x0f) | 0x40;
  rnds[8] = (rnds[8] & 0x3f) | 0x80;

  // Copy bytes to buffer, if provided
  if (buf) {
    for (var ii = 0; ii < 16; ++ii) {
      buf[i + ii] = rnds[ii];
    }
  }

  return buf || bytesToUuid_1(rnds);
}

var v4_1 = v4;

var version = "1.0.1";

var libVersion = "reactnative-" + version
    .split("-")
    .join(".")
    .split(".")
    .join("_");
var generateIframeUrl = function (dashboard, currentScreenmode) {
    var language = dashboard.language, loader = dashboard.loader, screenmode = dashboard.screenmode, authKey = dashboard.authKey, authToken = dashboard.authToken, chartDimensions = dashboard.chartDimensions, version = dashboard.version, dashboardId = dashboard.dashboardId, chartId = dashboard.chartId, chartEmbedding = dashboard.chartEmbedding;
    var queryString = {};
    var appServer = dashboard.appServer ? dashboard.appServer : "";
    if (language !== "auto") {
        queryString.language = language;
    }
    if (loader) {
        if (loader.background) {
            queryString.ldrbg = loader.background.replace("#", "--");
        }
        if (loader.fontColor) {
            queryString.ldrftclr = loader.fontColor.replace("#", "--");
        }
        if (loader.spinnerColor) {
            queryString.ldrspclr = loader.spinnerColor.replace("#", "--");
        }
        if (loader.spinnerBackground) {
            queryString.ldrspbg = loader.spinnerBackground.replace("#", "--");
        }
        if (loader.logoColor) {
            queryString.ldrlgclr = loader.logoColor.replace("#", "--");
        }
    }
    var specifiedScreenmode = screenmode &&
        ["mobile", "tablet", "desktop", "largescreen", "fixed"].indexOf(screenmode) > -1;
    if (specifiedScreenmode && screenmode === currentScreenmode) {
        queryString.screenmode = currentScreenmode;
    }
    if (authKey && authToken) {
        queryString.key = authKey;
        queryString.token = authToken;
    }
    if (chartEmbedding && chartDimensions) {
        if (chartDimensions.width) {
            queryString.width = chartDimensions.width;
        }
        if (chartDimensions.height) {
            queryString.height = chartDimensions.height;
        }
    }
    queryString.version = libVersion;
    var joinedQueryString = Object.keys(queryString)
        .map(function (key) {
        return key + "=" + encodeURIComponent(queryString[key]);
    })
        .join("&");
    var iframeUrl = "";
    if (chartEmbedding) {
        iframeUrl =
            appServer +
                "i/" +
                dashboardId +
                "/" +
                chartId +
                (joinedQueryString.length === 0 ? "" : "?" + joinedQueryString);
    }
    else {
        iframeUrl =
            appServer +
                "i/" +
                dashboardId +
                (joinedQueryString.length === 0 ? "" : "?" + joinedQueryString);
    }
    return sanitizeUrl(iframeUrl);
};
var sanitizeUrl = function (url) {
    var invalidPrototcolRegex = /^(%20|\s)*(javascript|data)/im;
    var ctrlCharactersRegex = /[^\x20-\x7E]/gim;
    var urlSchemeRegex = /^([^:]+):/gm;
    if (!url) {
        return "about:blank";
    }
    var sanitizedUrl = url.replace(ctrlCharactersRegex, "").trim();
    if (!isAbsoluteUrl(sanitizedUrl)) {
        return sanitizedUrl;
    }
    var urlSchemeParseResults = sanitizedUrl.match(urlSchemeRegex);
    if (!urlSchemeParseResults) {
        return sanitizedUrl;
    }
    var urlScheme = urlSchemeParseResults[0];
    if (invalidPrototcolRegex.test(urlScheme)) {
        return "about:blank";
    }
    return sanitizedUrl;
};
var isAbsoluteUrl = function (url) {
    var r = new RegExp("^(?:[a-z]+:)?//", "i");
    return r.test(url);
};

var CumulioDashboard = /** @class */ (function () {
    function CumulioDashboard(dashboardId, container) {
        this.appServer = "https://app.cumul.io/";
        this.host = "https://api.cumul.io";
        this.port = "443";
        this.version = "0.1.0";
        this.language = "auto";
        this.chartsRendered = false;
        this.chartDimensions = {
            width: "auto",
            height: "auto"
        };
        this.loaded = false;
        this.loader = {
            background: "#f9f9f9",
            fontColor: "#5a5a5a",
            spinnerColor: "rgba(255, 165, 0, 0.7)",
            spinnerBackground: "rgba(169, 169, 169, 0.14)",
            logoColor: "orange"
        };
        this._id = v4_1();
        this.dashboardId = dashboardId;
        this.container = container;
    }
    CumulioDashboard.prototype.extendWithComponentProps = function (props) {
        this.loader = {
            background: props.loaderBackground
                ? props.loaderBackground
                : this.loader.background,
            fontColor: props.loaderFontColor
                ? props.loaderFontColor
                : this.loader.fontColor,
            spinnerColor: props.loaderSpinnerColor
                ? props.loaderSpinnerColor
                : this.loader.spinnerColor,
            spinnerBackground: props.loaderSpinnerBackground
                ? props.loaderSpinnerBackground
                : this.loader.spinnerBackground,
            logoColor: props.loaderLogoColor
                ? props.loaderLogoColor
                : this.loader.logoColor
        };
        for (var prop in props) {
            this[prop] = props[prop];
        }
    };
    Object.defineProperty(CumulioDashboard.prototype, "chartEmbedding", {
        get: function () {
            return this.chartId ? true : false;
        },
        enumerable: true,
        configurable: true
    });
    CumulioDashboard.prototype.getIframeUrl = function (currentMode) {
        return generateIframeUrl(this, currentMode);
    };
    return CumulioDashboard;
}());

var _a;
var ScreenMode;
(function (ScreenMode) {
    ScreenMode["MOBILE"] = "mobile";
    ScreenMode["TABLET"] = "tablet";
    ScreenMode["DESKTOP"] = "desktop";
    ScreenMode["LARGE_SCREEN"] = "largeScreen";
    ScreenMode["FIXED"] = "fixed";
    ScreenMode["AUTO"] = "auto";
})(ScreenMode || (ScreenMode = {}));
var breakpoints = (_a = {},
    _a[ScreenMode.MOBILE] = [150, 767],
    _a[ScreenMode.TABLET] = [768, 1199],
    _a[ScreenMode.DESKTOP] = [1200, 1599],
    _a[ScreenMode.LARGE_SCREEN] = [1600, 9999],
    _a[ScreenMode.FIXED] = [],
    _a);
var MessageTypes;
(function (MessageTypes) {
    MessageTypes["INIT"] = "init";
    MessageTypes["CHANGED_FILTERS"] = "changedFilters";
    MessageTypes["DATA"] = "data";
    MessageTypes["LOAD"] = "load";
    MessageTypes["ERROR"] = "error";
    MessageTypes["EXPORT"] = "export";
    MessageTypes["CHARTS_RENDERED"] = "chartsRendered";
})(MessageTypes || (MessageTypes = {}));
var Translations = {
    initializing: {
        en: "Initializing...",
        nl: "Laden...",
        fr: "Chargement..."
    },
    errorDashboard: {
        en: "Oops, we could not load this dashboard!",
        nl: "Oeps, we konden het dashboard niet laden.",
        fr: "Le chargement a echouÃ©."
    },
    errorChart: {
        en: "Oops, we could not load this chart!",
        nl: "Oeps, we konden de grafiek niet laden.",
        fr: "Le chargement a echouÃ©."
    }
};

var Actions;
(function (Actions) {
    Actions["VALIDATE_DASHBOARD"] = "VALIDATE_DASHBOARD";
    Actions["SET_CURRENT_SCREEN_MODE"] = "SET_CURRENT_SCREEN_MODE";
    Actions["GET_DATA"] = "GET_DATA";
    Actions["SET_AUTHORIZATION"] = "SET_AUTHORIZATION";
    Actions["REFRESH_DATA"] = "REFRESH_DATA";
    Actions["RELOAD_DASHBOARD"] = "RELOAD_DASHBOARD";
    Actions["INIT"] = "INIT";
    Actions["CHANGE_FILTERS"] = "CHANGE_FILTERS";
    Actions["DATA"] = "DATA";
    Actions["LOAD"] = "LOAD";
    Actions["ERROR"] = "ERROR";
    Actions["EXPORT"] = "EXPORT";
    Actions["CHARTS_RENDERED"] = "CHARTS_RENDERED";
})(Actions || (Actions = {}));

var validateDashboardAction = function (payload) {
    return {
        type: Actions.VALIDATE_DASHBOARD,
        payload: payload
    };
};
var initAction = function (payload) {
    return {
        type: Actions.INIT,
        payload: payload
    };
};
var chartsRenderedAction = function (payload) {
    return {
        type: Actions.CHARTS_RENDERED,
        payload: payload
    };
};
var changeFiltersAction = function (payload) {
    return {
        type: Actions.CHANGE_FILTERS,
        payload: payload
    };
};
var dataAction = function (payload) {
    return {
        type: Actions.DATA,
        payload: payload
    };
};
var loadAction = function (payload) {
    return {
        type: Actions.LOAD,
        payload: payload
    };
};
var errorAction = function (payload) {
    return {
        type: Actions.ERROR,
        payload: payload
    };
};
var exportAction = function (payload) {
    return {
        type: Actions.EXPORT,
        payload: payload
    };
};
var setCurrentscreenModeAction = function (payload) {
    return {
        type: Actions.SET_CURRENT_SCREEN_MODE,
        payload: payload
    };
};
var getDataAction = function (payload) {
    return {
        type: Actions.GET_DATA,
        payload: payload
    };
};
var setAuthorizationAction = function (payload) {
    return {
        type: Actions.SET_AUTHORIZATION,
        payload: payload
    };
};
var refreshDataAction = function (payload) {
    if (payload === void 0) { payload = {}; }
    return {
        type: Actions.REFRESH_DATA,
        payload: payload
    };
};
var reloadDashboardAction = function () {
    return {
        type: Actions.RELOAD_DASHBOARD
    };
};

var CumulioContext = createContext(null);
function useCumulio() {
    var context = useContext(CumulioContext);
    if (!context) {
        throw new Error("useCumulio must be used within a CumulioProvider");
    }
    return context;
}

var useMessage = function (data, dispatch) {
    if (!data) {
        return;
    }
    switch (data.type) {
        case MessageTypes.INIT:
            dispatch(initAction({ replaceOldDashboards: true }));
            break;
        case MessageTypes.CHARTS_RENDERED:
            dispatch(chartsRenderedAction({
                chartsRendered: true,
                dashboardId: data.dashboard
            }));
            break;
        case MessageTypes.CHANGED_FILTERS:
            var filters = data.filters.filter(function (activeFilter) {
                return ["itemFilter", "global"].indexOf(activeFilter.properties.origin) ===
                    -1;
            });
            dispatch(changeFiltersAction({ dashboardId: data.dashboard, filters: filters }));
            break;
        case MessageTypes.DATA:
            dispatch(dataAction({ rawData: data.data }));
            break;
        case MessageTypes.LOAD:
            dispatch(loadAction({
                dashboardId: data.dashboard,
                dimensions: data.dimensions,
                language: data.language
            }));
            break;
        case MessageTypes.ERROR:
            dispatch(loadAction({
                dashboardId: data.dashboard,
                dimensions: data.dimensions,
                language: data.language
            }));
            dispatch(errorAction({
                dashboardId: data.dashboard,
                message: data.errorMsg.message
            }));
            break;
        case MessageTypes.EXPORT:
            dispatch(loadAction({
                dashboardId: data.dashboard,
                dimensions: data.dimensions,
                language: data.language
            }));
            dispatch(exportAction({
                dashboardId: data.dashboard,
                error: data.error ? data.error : null
            }));
            break;
    }
};

var CumulioComponent = function (props) {
    var switchScreenModeOnResize = props.switchScreenModeOnResize;
    // Refs
    var containerRef = useRef(null);
    var webViewRef = useRef(null);
    var screenWidth = Math.round(Dimensions.get('screen').width);
    var screenHeight = Math.round(Dimensions.get('screen').height);
    var _a = useState(null), iframeSrc = _a[0], setIframeSrc = _a[1];
    var _b = useState(0), webviewHeight = _b[0], setWebviewHeight = _b[1];
    var cssOptions = {
        borderWidth: 3,
        loaderSize: 32,
        minHeight: '100%',
    };
    var _c = useState(''), loadingMessage = _c[0], setLoadingMessage = _c[1];
    var _d = useCumulio(), state = _d.state, dispatch = _d.dispatch;
    var dashboard = createInitialDashboard(props);
    var error = state.error, dashboards = state.dashboards;
    var validatedDashboard = dashboards.find(function (d) { return d.dashboardId === dashboard.dashboardId; });
    if (validatedDashboard) {
        dashboard = validatedDashboard;
    }
    var chartEmbedding = dashboard.chartEmbedding, loader = dashboard.loader, loaded = dashboard.loaded, chartDimensions = dashboard.chartDimensions;
    useEffect(function () {
        dispatch(validateDashboardAction({ dashboard: dashboard, webView: webViewRef.current }));
        buildLoadingMessage();
        setIframeSrc(dashboard.getIframeUrl(state.currentScreenmode));
        getCurrentScreenmode();
        dispatch(chartsRenderedAction({
            chartsRendered: false,
            dashboardId: props.dashboardId
        }));
    }, [props.dashboardId]);
    useEffect(function () {
        var handler = function () {
            var screenWidth = Math.round(Dimensions.get('screen').width);
            var screenHeight = Math.round(Dimensions.get('screen').height);
            var script = "\n        (function(){\n          const dashboards = document.getElementsByClassName('cio-embed-dashboard');\n          for (const iframe of dashboards) {\n            iframe.style.width = \"" + screenWidth + "\";\n            iframe.style.height = \"" + screenHeight + "\";\n          }\n        })();\n        true;\n      ";
            webViewRef.current.injectJavaScript(script);
        };
        Dimensions.addEventListener('change', handler);
        return function () {
            Dimensions.removeEventListener('change', handler);
        };
    }, []);
    useEffect(function () {
        if (switchScreenModeOnResize) {
            getCurrentScreenmode();
        }
    }, [screenWidth, screenHeight]);
    // Initial screenmode -> set currentscreenmode
    var getCurrentScreenmode = function () {
        Object.keys(breakpoints).forEach(function (screenmode) {
            var breakpoint = breakpoints[screenmode];
            if (breakpoint[0] <= screenWidth && screenWidth <= breakpoint[1]) {
                dispatch(setCurrentscreenModeAction({ mode: screenmode }));
            }
        });
    };
    var buildLoadingMessage = function () {
        var msg = "";
        if (dashboard.language in Object.keys(Translations.initializing)) {
            msg = Translations.initializing[dashboard.language];
        }
        else {
            msg = Translations.initializing.en;
        }
        setLoadingMessage(msg);
    };
    var backgroundStyles = function () {
        var style = {
            height: "100%",
            width: "100%",
        };
        if (loader.background) {
            style.backgroundColor = dashboard.loader.background;
        }
        return [StyleSheet.create({ style: style }).style, styles.container];
    };
    var containerLoaderStyles = function () {
        var chartHeightDefined = chartEmbedding && chartDimensions.height !== 'auto';
        var style = {
            height: chartHeightDefined ? chartDimensions.height : cssOptions.minHeight,
            display: loaded ? "none" : "flex",
            justifyContent: 'center',
        };
        return [StyleSheet.create({ style: style }).style];
    };
    var loaderStyles = function () {
        var style = {
            height: 40,
            justifyContent: "center",
            alignItems: "center",
            alignSelf: "center",
        };
        return [StyleSheet.create({ style: style }).style];
    };
    var ciolmStyles = function () {
        var style = {
            color: loader.fontColor,
            fontSize: 18
        };
        return [StyleSheet.create({ style: style }).style, styles.container];
    };
    var iframeStyles = function () {
        var styleObject = { opacity: 0, height: '100%', width: screenWidth };
        if (chartEmbedding) {
            if (chartDimensions.height !== 'auto') {
                styleObject.height = chartDimensions.height + 'px';
            }
            else {
                styleObject.height = '200px';
            }
            // Standard Width
            if (chartDimensions.width !== 'auto') {
                styleObject.width = chartDimensions.width + 'px';
            }
            else {
                styleObject.width = '100%';
            }
        }
        // If status loaded, show iframe
        if (loaded) {
            styleObject.opacity = 1;
        }
        var stringStyle = "";
        Object.keys(styleObject).forEach(function (key) {
            stringStyle += key + ":" + styleObject[key] + ";";
        });
        return stringStyle;
    };
    var styles = StyleSheet.create({
        container: {
            flex: 1,
        },
    });
    var html = "\n    <html>\n    <head>\n      <meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\">\n    </head>\n      <body>\n        <script>\n          window.addEventListener('message', (event) => {\n            window.ReactNativeWebView.postMessage(JSON.stringify(event.data));\n          });\n\n          window.location.hash = 1;\n          var calculator = document.createElement(\"div\");\n          calculator.id = \"height-calculator\";\n          while (document.body.firstChild) {\n              calculator.appendChild(document.body.firstChild);\n          }\n          document.body.appendChild(calculator);\n          document.title = calculator.scrollHeight;\n        </script>\n        <style>\n          body, .cio-embed-dashboard {\n            margin: 0;\n            padding: 0;\n            border: 0;\n          }\n        </style>\n        <iframe class=\"cio-embed-dashboard\" style=\"" + iframeStyles() + "\" src=\"" + iframeSrc + "\"/>\n      </body>\n    </html>\n  ";
    var onNavigationChange = function (event) {
        alert("lol");
        if (event.title) {
            var htmlHeight = Number(event.title); //convert to number
            setWebviewHeight(htmlHeight);
        }
    };
    return (React.createElement(View, { ref: containerRef, style: backgroundStyles() },
        React.createElement(View, { style: containerLoaderStyles() },
            React.createElement(View, { style: loaderStyles() },
                !error && (React.createElement(React.Fragment, null, !chartEmbedding && (React.createElement(Text, { style: ciolmStyles() }, loadingMessage)))),
                error && error.displayableMessage && (React.createElement(Text, { style: ciolmStyles() }, error.displayableMessage)))),
        React.createElement(WebView, { ref: webViewRef, source: { html: html }, style: { height: webviewHeight }, automaticallyAdjustContentInsets: false, onNavigationStateChange: function () { return onNavigationChange; }, onMessage: function (event) {
                var data = event.nativeEvent.data;
                useMessage(JSON.parse(data), dispatch);
            } })));
};
var createInitialDashboard = function (props) {
    var dashboard = new CumulioDashboard(props.dashboardId);
    dashboard.extendWithComponentProps(props);
    return dashboard;
};
CumulioComponent.defaultProps = {
    language: "auto",
    screenmode: ScreenMode.AUTO,
    switchScreenmodeOnResize: true
};
CumulioComponent.propTypes = {
    screenmode: propTypes.oneOf(Object.values(ScreenMode)),
};

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

var libVersion$1 = "react-" + version
    .split("-")
    .join(".")
    .split(".")
    .join("_");
var getData = function (state, _a) {
    var chartId = _a.chartId, dashboard = _a.dashboard;
    var script = "\n    (function(){\n      const dashboards = document.getElementsByClassName('cio-embed-dashboard');\n      for (const iframe of dashboards) {\n        if (true === " + (dashboard.dashboardId ? true : false) + ") {\n          if (iframe && iframe.src.includes(\"" + dashboard.dashboardId + "\")) {\n            iframe.contentWindow.postMessage({ action: 'getData', id: \"" + chartId + "\", _version: \"" + libVersion$1 + "\" }, '*');\n          }\n        } else {\n          iframe.contentWindow.postMessage({ action: 'getData', id: \"" + chartId + "\", _version: \"" + libVersion$1 + "\" }, '*');\n        }\n      }\n    })();\n    true;\n  ";
    state.dashboards.forEach(function (dashboard) {
        dashboard.webView.injectJavaScript(script);
    });
    return state;
};

var libVersion$2 = "react-" + version
    .split("-")
    .join(".")
    .split(".")
    .join("_");
var refreshData = function (state, _a) {
    var id = _a.id;
    var iframeId = id ? id : null;
    var script = "\n    (function(){\n      const dashboards = document.getElementsByClassName('cio-embed-dashboard');\n      for (const iframe of dashboards) {\n        iframe.contentWindow.postMessage({ action: 'refreshData', id: " + iframeId + ", _version: \"" + libVersion$2 + "\" }, '*');\n      }\n    })();\n    true;\n  ";
    state.dashboards.forEach(function (dashboard) {
        dashboard.webView.injectJavaScript(script);
    });
    return state;
};

var libVersion$3 = "react-" + version
    .split("-")
    .join(".")
    .split(".")
    .join("_");
var reloadDashboard = function (state) {
    var script = "\n    (function(){\n      const dashboards = document.getElementsByClassName('cio-embed-dashboard');\n      for (const iframe of dashboards) {\n        iframe.contentWindow.postMessage({ action: 'refreshData', _version: \"" + libVersion$3 + "\" }, '*');\n      }\n    })();\n    true;\n  ";
    state.dashboards.forEach(function (dashboard) {
        dashboard.webView.injectJavaScript(script);
    });
    return state;
};

var libVersion$4 = "react-" + version
    .split("-")
    .join(".")
    .split(".")
    .join("_");
var setAuthorization = function (state, _a) {
    var authKey = _a.authKey, authToken = _a.authToken, dashboard = _a.dashboard;
    var script = "\n    (function(){\n      const dashboards = document.getElementsByClassName('cio-embed-dashboard');\n      for (const iframe of dashboards) {\n        if (true === " + (dashboard.dashboardId ? true : false) + ") {\n          iframe.contentWindow.postMessage(\n            { action: 'setAuthorization', key: \"" + authKey + "\", token: \"" + authToken + "\", _version: \"" + libVersion$4 + "\", dashboardId: \"" + dashboard.dashboardId + "\" },\n            '*',\n          );\n        }\n        else {\n          iframe.contentWindow.postMessage(\n            { action: 'setAuthorization', key: \"" + authKey + "\", token: \"" + authToken + "\", _version: \"" + libVersion$4 + "\" },\n            '*',\n          );\n        }\n      }\n    })();\n    true;\n  ";
    state.dashboards.forEach(function (dashboard) {
        dashboard.webView.injectJavaScript(script);
    });
    return state;
};

var validateDashboard = function (state, _a) {
    var dashboard = _a.dashboard, webView = _a.webView;
    var cleanedDashboard = cleanUpParams(dashboard);
    if (webView) {
        cleanedDashboard.webView = webView;
    }
    var screenmode = cleanedDashboard.screenmode, chartDimensions = cleanedDashboard.chartDimensions, switchScreenmodeOnResize = cleanedDashboard.switchScreenmodeOnResize;
    if (screenmode && screenmode !== "auto") {
        switchScreenmodeOnResize = false;
    }
    if (chartDimensions.width !== "auto") {
        chartDimensions.width =
            (chartDimensions.width + "").replace("px", "") || "auto";
    }
    if (chartDimensions.height !== "auto") {
        chartDimensions.height =
            (chartDimensions.height + "").replace("px", "") || "auto";
    }
    var newState = Object.assign({}, state);
    var dashboardExists = false;
    newState.dashboards &&
        newState.dashboards.forEach(function (d) {
            // Dashboard exists -- Update Dashboard
            if (cleanedDashboard.dashboardId === d.dashboardId) {
                d = cleanedDashboard;
                dashboardExists = true;
            }
        });
    if (!dashboardExists) {
        // if (newState.replaceOldDashboards === true) {
        //   newState.dashboards = [];
        //   newState.replaceOldDashboards = false;
        // }
        newState.dashboards.push(cleanedDashboard);
    }
    return newState;
};
var cleanUpParams = function (properties) {
    for (var prop in properties) {
        if (properties[prop] === null || properties[prop] === undefined) {
            delete properties[prop];
        }
        if (typeof properties[prop] === "object") {
            properties[prop] = cleanUpParams(properties[prop]);
        }
    }
    return properties;
};

var parseFilter = function (filter) {
    var parsedFilter = {};
    if (filter.parameters) {
        parsedFilter = {
            columnId: filter.parameters[0].column_id,
            value: filter.parameters[1],
            datasetId: filter.parameters[0].dataset_id
        };
    }
    else {
        parsedFilter = { columnId: filter.column_id, value: filter.value };
    }
    if (filter.properties) {
        // This is chartId of filter.
        parsedFilter.chartId = filter.properties.viz;
    }
    switch (filter.expression) {
        case "? between ?":
            parsedFilter.expression = "between";
            break;
        case "? > ?":
            parsedFilter.expression = "greater than";
            break;
        case "? >= ?":
            parsedFilter.expression = "greater than or equal";
            break;
        case "? <= ?":
            parsedFilter.expression = "smaller than or equal";
            break;
        case "? < ?":
            parsedFilter.expression = "smaller than";
            break;
        case "? in ?":
            parsedFilter.expression = "is in";
            break;
        case "? = ?":
            parsedFilter.expression = "equals";
            break;
        default:
            parsedFilter.expression = "equals";
    }
    return parsedFilter;
};
var parseFilters = function (filters) {
    return filters.map(function (filter) { return parseFilter(filter); });
};
var changeFiltersMessage = function (state, _a) {
    var dashboardId = _a.dashboardId, filters = _a.filters;
    var parsedFilters = parseFilters(filters);
    var newState = Object.assign({}, state);
    var index = newState.filters.findIndex(function (filter) { return filter.dashboardId === dashboardId; });
    if (filters.length === 0) {
        newState.filters.splice(index, 1);
        return newState;
    }
    if (index > -1) {
        newState.filters[index].activeFilters = parsedFilters;
    }
    else {
        newState.filters.push({
            activeFilters: parsedFilters,
            dashboardId: dashboardId
        });
    }
    return newState;
};

var dataMessage = function (state, _a) {
    var rawData = _a.rawData;
    var data = [];
    var isArray = function (value) { return Array.isArray(value) || value instanceof Array; };
    var processData = function (value) {
        return value !== null && value !== undefined && typeof value === "object"
            ? value.id
            : value;
    };
    rawData === null || rawData === void 0 ? void 0 : rawData.forEach(function (row) {
        var processedRow = [];
        if (isArray(row))
            row.forEach(function (value) {
                processedRow.push(processData(value));
            });
        else
            processedRow.push(processData(row));
        data.push(processedRow);
    });
    return __assign(__assign({}, state), { data: data });
};

var setStatus = function (state, _a) {
    var dashboard = _a.dashboard, status = _a.status;
    dashboard.status = status;
    return __assign(__assign({}, state), { filters: [], dashboards: state.dashboards.map(function (existingDashboard) {
            if (existingDashboard.dashboardId === dashboard.dashboardId) {
                return dashboard;
            }
            return existingDashboard;
        }) });
};

var errorMessage = function (state, _a) {
    var dashboardId = _a.dashboardId, message = _a.message;
    var dashboard = state.dashboards.find(function (dashboard) { return dashboard.dashboardId === dashboardId; });
    state = setStatus(state, { dashboard: dashboard, status: "error" });
    return __assign(__assign({}, state), { error: {
            message: message,
            displayableMessage: message
        } });
};

var exportMessage = function (state, _a) {
    var dashboardId = _a.dashboardId, error = _a.error;
    var dashboard = state.dashboards.find(function (dashboard) { return dashboard.dashboardId === dashboardId; });
    state = setStatus(state, { dashboard: dashboard, status: "export" });
    if (error) {
        console.error(error.msg);
    }
    return state;
};

var loadMessage = function (state, _a) {
    var dashboardId = _a.dashboardId;
    var dashboard = state.dashboards.find(function (dashboard) { return dashboard.dashboardId === dashboardId; });
    dashboard.loaded = true;
    state = setStatus(state, { dashboard: dashboard, status: "loaded" });
    return __assign(__assign({}, state), { dashboards: state.dashboards.map(function (existingDashboard) {
            if (existingDashboard.dashboardId === dashboard.dashboardId) {
                return dashboard;
            }
            return existingDashboard;
        }) });
};

var chartsRenderedMessage = function (state, _a) {
    var dashboardId = _a.dashboardId, chartsRendered = _a.chartsRendered;
    var dashboard = state.dashboards.find(function (dashboard) { return dashboard.dashboardId === dashboardId; });
    try {
        if (!dashboard) {
            return state;
        }
        dashboard.chartsRendered = chartsRendered;
        return __assign(__assign({}, state), { dashboards: state.dashboards.map(function (existingDashboard) {
                if (existingDashboard.dashboardId === dashboard.dashboardId) {
                    return dashboard;
                }
                return existingDashboard;
            }) });
    }
    catch (err) {
        return state;
    }
};

var initialState = {
    dashboards: [],
    filters: [],
    data: [],
    containerWidth: null,
    replaceOldDashboards: false,
    debug: false
};
function reducer(state, action) {
    try {
        switch (action.type) {
            case Actions.VALIDATE_DASHBOARD:
                return validateDashboard(state, action.payload);
            case Actions.SET_CURRENT_SCREEN_MODE:
                return __assign(__assign({}, state), { currentScreenmode: action.payload.mode });
            case Actions.INIT:
                return __assign(__assign({}, state), { replaceOldDashboards: action.payload.replaceOldDashboards });
            case Actions.CHARTS_RENDERED:
                return chartsRenderedMessage(state, action.payload);
            case Actions.CHANGE_FILTERS:
                return changeFiltersMessage(state, action.payload);
            case Actions.DATA:
                return dataMessage(state, action.payload);
            case Actions.LOAD:
                return loadMessage(state, action.payload);
            case Actions.ERROR:
                return errorMessage(state, action.payload);
            case Actions.EXPORT:
                return exportMessage(state, action.payload);
            case Actions.GET_DATA:
                return getData(state, action.payload);
            case Actions.SET_AUTHORIZATION:
                return setAuthorization(state, action.payload);
            case Actions.REFRESH_DATA:
                return refreshData(state, action.payload);
            case Actions.RELOAD_DASHBOARD:
                return reloadDashboard(state);
            default:
                throw new Error();
        }
    }
    catch (err) {
        return __assign(__assign({}, state), { error: {
                message: err.message
            } });
    }
}

export { CumulioComponent, CumulioContext, MessageTypes, ScreenMode, Translations, breakpoints, getDataAction, initialState, reducer, refreshDataAction, reloadDashboardAction, setAuthorizationAction, useCumulio };
//# sourceMappingURL=index.es.js.map
