# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/)
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [v1.0.1](https://bitbucket.org/cumulio/react-native-cumulio/compare/v1.0.1..v1.0.0) - 2021-07-05

### Commits

- Feature: version to url from package.json && add _version property to postMessage event to the dashboard [`35dbd89`](https://bitbucket.org/cumulio/react-native-cumulio/commits/35dbd895e46f7961fce9c9d6cd185d67683e5058)

## [v1.0.0](https://bitbucket.org/cumulio/react-native-cumulio/compare/v1.0.0..v0.1.0-beta.5) - 2021-03-18

### Commits

- Chore: Added chartDimensions to doc [`850eb28`](https://bitbucket.org/cumulio/react-native-cumulio/commits/850eb28e6026febfe99423f775e28c43316aa246)
- Added chartDimensions to doc [`0e1f602`](https://bitbucket.org/cumulio/react-native-cumulio/commits/0e1f602a549058d3ee296dc64803d2f95ab50c3b)

## v0.1.0-beta.5 - 2021-03-04

### Merged

- Feat: ASA-1199686430399076 | Customer requested chartsRendered event (added a state variable for that) [`#2`](https://bitbucket.org/cumulio/react-native-cumulio/pull-requests/2)
- Fix: ASA-1199686672503970 | Customer requested datasetId and chartId in filters. [`#1`](https://bitbucket.org/cumulio/react-native-cumulio/pull-requests/1)

### Commits

- Fix: ASA-1200013987970618 | Comment out remove all dashboards [`3568b49`](https://bitbucket.org/cumulio/react-native-cumulio/commits/3568b49c71ce4c2f8d47788bc96de8fdda9afb93)
- Merged master into fix/yannick-data-message [`1968b89`](https://bitbucket.org/cumulio/react-native-cumulio/commits/1968b89add17ef51ab6a77dc3f748174bc1f714d)
- Initial commit [`a31c813`](https://bitbucket.org/cumulio/react-native-cumulio/commits/a31c813908fc995fc6a86b5a239e30a4074e11f9)
- Feature: add dependencies [`c1f3b27`](https://bitbucket.org/cumulio/react-native-cumulio/commits/c1f3b27e98bfbd94ef3dc2d36d3bf671202902d2)
- Add shared files [`4bbf568`](https://bitbucket.org/cumulio/react-native-cumulio/commits/4bbf568c2bac057305f89cd096df2ae141ed70ca)
- Add example app [`ca5a4b8`](https://bitbucket.org/cumulio/react-native-cumulio/commits/ca5a4b839fd3f9bfe9ac0a2f1ff2fec8b8dd6995)
- Removed dist folder and added to .gitignore [`b272c69`](https://bitbucket.org/cumulio/react-native-cumulio/commits/b272c69b0e8c3651aeddc1834f1411578ffcfdac)
- Create 0.1.0 release [`3d76aa9`](https://bitbucket.org/cumulio/react-native-cumulio/commits/3d76aa915de18508e9e86dfc065872fb7c364326)
- Add proper readme [`6aa1c91`](https://bitbucket.org/cumulio/react-native-cumulio/commits/6aa1c9178eb482667114469aef36b17b29d44702)
- Fixed data message function [`fd43bd0`](https://bitbucket.org/cumulio/react-native-cumulio/commits/fd43bd0a5a243e79f96a21918033c02043315351)
- Change example to use the npm package available [`3a5315b`](https://bitbucket.org/cumulio/react-native-cumulio/commits/3a5315ba6207949be6654c8c1630f97ffdcdf253)
- Example version [`1db0261`](https://bitbucket.org/cumulio/react-native-cumulio/commits/1db026174fd8b8dff64c382b53f148690d048e57)
- Upgrade react-native-cumulio to beta-4 in example app [`6944429`](https://bitbucket.org/cumulio/react-native-cumulio/commits/6944429bd150b637786fab90dcce3defc353e709)
- Add link to example [`8b0e730`](https://bitbucket.org/cumulio/react-native-cumulio/commits/8b0e73059fa15942a18ffaa2c7bb09cae4d8bc79)
- Set version [`3f77acf`](https://bitbucket.org/cumulio/react-native-cumulio/commits/3f77acf635cbb952e544f7c08734bc609d10103c)
- Run build on prepare [`b23c84a`](https://bitbucket.org/cumulio/react-native-cumulio/commits/b23c84ad8218e41ee879146269b1f984c25bf00a)
