/// <reference types="react" />
import PropTypes from 'prop-types';
import { IPublicProps, ScreenMode } from './cumulio-model';
declare const CumulioComponent: {
    (props: IPublicProps): JSX.Element;
    defaultProps: {
        language: string;
        screenmode: ScreenMode;
        switchScreenmodeOnResize: boolean;
    };
    propTypes: {
        screenmode: PropTypes.Requireable<ScreenMode>;
    };
};
export default CumulioComponent;
